package IceBearSoft::CSconvert;
require Exporter;
@ISA = qw(Exporter);

use Text::Abbrev;

BEGIN {

# Code tables, marked changes between Win 1250 and ISO 8859/2
#                      |        |||    ||             |        |||    ||
$cp852 = 'Ԃ؉墓眣쫧Ґבޚ퍦';
$mac   = 'ÊÓÒþ˗ÀÑý매';
$koi8cs= 'іÀŖɖ̖Җٖ얖';
$kamen = '+Ӌ';
$ascii = 'aaacccdeeeiilllnnooorrsstuuuyzzAAACCCDEEEIILLLNNOOORRSSTUUUYZZ??';
$isoL2 = '嵳ťئݬߧ';
$w1250 = '徳ż،ݏߧ';
#                      ^        ^^^    ^^             ^        ^^^    ^^
abbrev(*EncNames, qw(cp852 852 os/2 dos mac koi8cs kamenicky ascii isol2 unix 8859-2
                     windows1250 cp1250 1250));
$cnv{'cp852'} = $cnv{'852'} = $cnv{'os/2'} = $cnv{'dos'} = $cp852;
$cnv{'mac'} = $mac;
$cnv{'koi8cs'} = $koi8cs;
$cnv{'kamenicky'} = $kamen;
$cnv{'ascii'} = $ascii;
$cnv{'isol2'} = $cnv{'unix'} = $cnv{'8859-2'} = $isoL2;
$cnv{'windows1250'} = $cnv{'cp1250'} = $cnv{'1250'} = $w1250;
}

sub new ($$$) {
  my ($class, $fromEnc, $toEnc) = @_;
  my $this = {};
  my $q = $EncNames{lc $fromEnc};
  die "Conversion from ASCII not supported" if $q eq 'ascii';
  $this->{'from'} = $IceBearSoft::CSconvert::cnv{$q};
  $this->{'to'} = $IceBearSoft::CSconvert::cnv{$EncNames{lc $toEnc}};
  die "Wrong encoding names" unless $this->{'from'} && $this->{'to'};
  return bless $this, $class;
}

sub convert ($$) {
  my ($this, $src) = @_;
  my ($from, $to) = @$this{'from', 'to'};
  my $res;
  SWITCH: for (ref $src) {
    /^$/ && do {
      $res = $src;
      eval "\$res =~ tr/$from/$to/";
      last SWITCH;
    };
    /SCALAR/ && do {
      $_ = $$src;  eval "tr/$from/$to/";  $res = $_;
      last SWITCH;
    };
    /ARRAY/ && do {
      $res = [];
      foreach (@$src) {
        eval "tr/$from/$to/";
        push @$res, $_;
      }
      last SWITCH;
    };
    die "Argument of type $_ is not supported";
  }
  return $res;
}

