package IceBearSoft::ZWdebug;

# ZW debugging functions

require Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(
  list_array
  list_hash
  list_scalar
  list_scalars
);

sub list_array($;@);
sub list_hash($;%);
sub list_scalar($);
sub list_scalars(@);

sub list_hash {
  my $name = shift;
  if ($#_ >= 0) {
    my $hash = shift;
    print "\n", $name, "\n";
    foreach $key (sort(keys %$hash)) {
      print '   ', $key, " => ", $$hash{$key}, "\n";
    }
  }
  else {
    $package = (caller)[0];
    $what = $name;
    $what = $package . '::' . $name if not ($name =~ /::/);
    list_hash $name, \%$what;
  }
}

sub list_array {
  my $name = shift;
  if ($#_ >= 0) {
    my $array = shift;
    print "\n", $name, "\n";
    foreach (@$array) {
      print '  -> ', $_, "\n";
    }
  }
  else {
    $package = (caller)[0];
    $what = $name;
    $what = $package . '::' . $name if not ($name =~ /::/);
    list_array $name, \@$what;
  }
}

sub list_scalar {
  my $name = shift;
  $package = (caller)[0];
  $what = $name;
  $what = $package . '::' . $name if not ($name =~ /::/);
  print $name, ' = ', $$what, "\n";
}

sub list_scalars {
  $package = (caller)[0];
  foreach $name (@_) {
    $what = $name;
    $what = $package . '::' . $name if not ($name =~ /::/);
    print $name, ' = ', $$what, "\n";
  }
}
