#!perl5

# This script reads an SGML or XML file and all tags are removed.
# The resulting text file is printed on standard output.

# (C) Z. Wagner -- Ice Bear Soft, 24 Feb 2000 

use IceBearSoft::ZWsgml;

($fn, $rest) = @ARGV;
if ($rest) { die "Superfluous arguments: $rest\n"; }

open (SGML, $fn) or die "Can't open $fn\n";
$parser = new IceBearSoft::ZWsgml (\*SGML); # open the file
do {
  ($k, $v) = $parser->nextTag; # get next tag
  if (length($k) > 0) { # tag found
    print ' '; # single space instead of a tag
  }
  else { # print plain text (outside tags)
    $v =~ s/\&quot;/\"/g;
    $v =~ s/\&lt;/</g;
    $v =~ s/\&gt;/>/g;
    $v =~ s/\&amp;/\&/g;
    print "\n", $v if length($v) > 0;
  }
} while (length($k) + length($v) > 0);
close SGML;
