#!perl5
use IceBearSoft::ZWurl(url_encode, url_decode, split_url, abs_url, localize_url, http_url);
use IceBearSoft::ZWdebug(list_hash);

# Test URL encoding/decoding

$a = "a + b?\015\012\011&=5%";
$b = url_encode $a;
$c = url_decode $b;
print $a, "\n";  print $b, "\n";  print $c, "\n";
print "OK\n\n" if $a eq $c;
print "Failed!\n\n" if $a ne $c;

$a = "%2525";
$b = url_decode $a;
print "Test decoding $a: $b\n";

$a = "%\\";
$b = url_encode $a;
print "Test encoding $a: $b\n";

# Test URL splitting

%u = split_url 'http://www.cz/dir/subdir/file.html#nic';
list_hash 'URL splitting', \%u;
%u = split_url 'http://www.cz/dir/subdir/file.html';
list_hash 'URL splitting', \%u;
%u = split_url 'http://www.cz/dir/subdir/file.html?a=b&c=d';
list_hash 'URL splitting', \%u;
%u = split_url 'http://www.cz/dir/subdir/file.html?a=b&c=d#some-label';
list_hash 'URL splitting', \%u;
%u = split_url 'http://www.cz:10954/dir/subdir/';
list_hash 'URL splitting', \%u;
%u = split_url 'http://www.cz:1095';
list_hash 'URL splitting', \%u;
%u = split_url 'http://www.cz';
list_hash 'URL splitting', \%u;

# Test abs path

$r = 'http://www.icpf.cas.cz/users/wagner/default.htm';
print "\nReferer = $r\n";
$a = 'index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = '../wagner/index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = '../index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = '../kocka/index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = '/index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = 'kocka/index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = '../../kocka/index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = '//www.cz/index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = 'http://www.cz/index.html';
print "$a => ", (abs_url $r, $a), "\n";
$a = './';
print "$a => ", (abs_url $r, $a), "\n";
$a = '.';
print "$a => ", (abs_url $r, $a), "\n";
$a = '..';
print "$a => ", (abs_url $r, $a), "\n";
$a = '../';
print "$a => ", (abs_url $r, $a), "\n";

# Test localization

sub loc($$);
print "\nReferer for loc test = $r\n";
loc $r, 'index.html';
loc $r, '../index.html';
loc $r, '../wagner/index.html';
loc $r, '../kocka/index.html';
loc $r, '/index.html';
loc $r, '//www.cz/index.html';
loc $r, 'http://www.icpf.cas.cz/';
loc $r, 'http://www.icpf.cas.cz';
loc $r, './';
loc $r, '.';
loc $r, '..';
loc $r, '../';

# Test http_url

sub ht($);
print "\nhttp_url test\n";
ht 'http://www.icpf.cas.cz';
ht 'ftp://www.icpf.cas.cz';
ht '//www.icpf.cas.cz/wagner/';
ht 'www.icpf.cas.cz/wagner/frame.html';

# Subroutines

sub loc {
  my ($r, $a) = @_;
  print "$a => ", (localize_url $r, $a), "\n";
  my $b = abs_url $r, $a;
  print "$b => ", (localize_url $r, $b), "\n";
}

sub ht {
  my $x = shift;
  print "$x -> ", (http_url $x), "\n";
}
